import { RectangularStructureParams } from "./rectangular_structure_params";
import { StructureFlowMode } from "./structure";
import { StructureGateCunge80 } from "./structure_gate_cunge80";
import { LoiDebit } from "./structure_props";

export class StructureWeirCunge80 extends StructureGateCunge80 {

    constructor(prms: RectangularStructureParams, dbg: boolean = false) {
        super(prms, dbg);
        this._loiDebit = LoiDebit.WeirCunge80;
        this.prms.W.visible = false;
    }

    protected getFlowMode(): StructureFlowMode {
        return StructureFlowMode.WEIR;
    }

}
